<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>StatusLine xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../apidocs/org/apache/commons/httpclient/StatusLine.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/StatusLine.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../org/apache/commons/httpclient/package-summary.html">org.apache.commons.httpclient</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <em>/**<em>*</em></em>
<a name="34" href="#34">34</a>  <em> * Represents a Status-Line as returned from a HTTP server.</em>
<a name="35" href="#35">35</a>  <em> *</em>
<a name="36" href="#36">36</a>  <em> * &lt;a href="<a href="http://www.ietf.org/rfc/rfc2616.txt" target="alexandria_uri">http://www.ietf.org/rfc/rfc2616.txt</a>">RFC2616&lt;/a> states</em>
<a name="37" href="#37">37</a>  <em> * the following regarding the Status-Line:</em>
<a name="38" href="#38">38</a>  <em> * &lt;pre></em>
<a name="39" href="#39">39</a>  <em> * 6.1 Status-Line</em>
<a name="40" href="#40">40</a>  <em> *</em>
<a name="41" href="#41">41</a>  <em> *  The first line of a Response message is the Status-Line, consisting</em>
<a name="42" href="#42">42</a>  <em> *  of the protocol version followed by a numeric status code and its</em>
<a name="43" href="#43">43</a>  <em> *  associated textual phrase, with each element separated by SP</em>
<a name="44" href="#44">44</a>  <em> *  characters. No CR or LF is allowed except in the final CRLF sequence.</em>
<a name="45" href="#45">45</a>  <em> *</em>
<a name="46" href="#46">46</a>  <em> *      Status-Line = HTTP-Version SP Status-Code SP Reason-Phrase CRLF</em>
<a name="47" href="#47">47</a>  <em> * &lt;/pre></em>
<a name="48" href="#48">48</a>  <em> * &lt;p></em>
<a name="49" href="#49">49</a>  <em> * This class is immutable and is inherently thread safe.</em>
<a name="50" href="#50">50</a>  <em> *</em>
<a name="51" href="#51">51</a>  <em> * @see HttpStatus</em>
<a name="52" href="#52">52</a>  <em> * @author &lt;a href="<a href="mailto:jsdever@apache.org" target="alexandria_uri">mailto:jsdever@apache.org</a>">Jeff Dever&lt;/a></em>
<a name="53" href="#53">53</a>  <em> * @author &lt;a href="<a href="mailto:mbowler@GargoyleSoftware.com" target="alexandria_uri">mailto:mbowler@GargoyleSoftware.com</a>">Mike Bowler&lt;/a></em>
<a name="54" href="#54">54</a>  <em> * @version $Id: StatusLine.java 608014 2008-01-02 05:48:53Z rolandw $</em>
<a name="55" href="#55">55</a>  <em> * @since 2.0</em>
<a name="56" href="#56">56</a>  <em> */</em>
<a name="57" href="#57">57</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../org/apache/commons/httpclient/StatusLine.html">StatusLine</a> {
<a name="58" href="#58">58</a>  
<a name="59" href="#59">59</a>      <em class="comment">// ----------------------------------------------------- Instance Variables</em>
<a name="60" href="#60">60</a>  
<a name="61" href="#61">61</a>      <em>/**<em>* The original Status-Line. */</em></em>
<a name="62" href="#62">62</a>      <strong>private</strong> <strong>final</strong> String statusLine;
<a name="63" href="#63">63</a>  
<a name="64" href="#64">64</a>      <em>/**<em>* The HTTP-Version. */</em></em>
<a name="65" href="#65">65</a>      <strong>private</strong> <strong>final</strong> String httpVersion;
<a name="66" href="#66">66</a>  
<a name="67" href="#67">67</a>      <em>/**<em>* The Status-Code. */</em></em>
<a name="68" href="#68">68</a>      <strong>private</strong> <strong>final</strong> <strong>int</strong> statusCode;
<a name="69" href="#69">69</a>  
<a name="70" href="#70">70</a>      <em>/**<em>* The Reason-Phrase. */</em></em>
<a name="71" href="#71">71</a>      <strong>private</strong> <strong>final</strong> String reasonPhrase;
<a name="72" href="#72">72</a>  
<a name="73" href="#73">73</a>  
<a name="74" href="#74">74</a>      <em class="comment">// ----------------------------------------------------------- Constructors</em>
<a name="75" href="#75">75</a>  
<a name="76" href="#76">76</a>      <em>/**<em>*</em></em>
<a name="77" href="#77">77</a>  <em>     * Default constructor.</em>
<a name="78" href="#78">78</a>  <em>     *</em>
<a name="79" href="#79">79</a>  <em>     * @param statusLine the status line returned from the HTTP server</em>
<a name="80" href="#80">80</a>  <em>     * @throws HttpException if the status line is invalid</em>
<a name="81" href="#81">81</a>  <em>     */</em>
<a name="82" href="#82">82</a>      <strong>public</strong> <a href="../../../../org/apache/commons/httpclient/StatusLine.html">StatusLine</a>(<strong>final</strong> String statusLine) throws HttpException {
<a name="83" href="#83">83</a>  
<a name="84" href="#84">84</a>          <strong>int</strong> length = statusLine.length();
<a name="85" href="#85">85</a>          <strong>int</strong> at = 0;
<a name="86" href="#86">86</a>          <strong>int</strong> start = 0;
<a name="87" href="#87">87</a>          <strong>try</strong> {
<a name="88" href="#88">88</a>              <strong>while</strong> (Character.isWhitespace(statusLine.charAt(at))) {
<a name="89" href="#89">89</a>                  ++at;
<a name="90" href="#90">90</a>                  ++start;
<a name="91" href="#91">91</a>              }
<a name="92" href="#92">92</a>              <strong>if</strong> (!<span class="string">"HTTP"</span>.equals(statusLine.substring(at, at += 4))) {
<a name="93" href="#93">93</a>                  <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/HttpException.html">HttpException</a>(<span class="string">"Status-Line '"</span> + statusLine 
<a name="94" href="#94">94</a>                      + <span class="string">"' does not start with HTTP"</span>);
<a name="95" href="#95">95</a>              }
<a name="96" href="#96">96</a>              <em class="comment">//handle the HTTP-Version</em>
<a name="97" href="#97">97</a>              at = statusLine.indexOf(<span class="string">" "</span>, at);
<a name="98" href="#98">98</a>              <strong>if</strong> (at &lt;= 0) {
<a name="99" href="#99">99</a>                  <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/ProtocolException.html">ProtocolException</a>(
<a name="100" href="#100">100</a>                         <span class="string">"Unable to parse HTTP-Version from the status line: '"</span>
<a name="101" href="#101">101</a>                         + statusLine + <span class="string">"'"</span>);
<a name="102" href="#102">102</a>             }
<a name="103" href="#103">103</a>             <strong>this</strong>.httpVersion = (statusLine.substring(start, at)).toUpperCase();
<a name="104" href="#104">104</a> 
<a name="105" href="#105">105</a>             <em class="comment">//advance through spaces</em>
<a name="106" href="#106">106</a>             <strong>while</strong> (statusLine.charAt(at) == ' ') {
<a name="107" href="#107">107</a>                 at++;
<a name="108" href="#108">108</a>             }
<a name="109" href="#109">109</a> 
<a name="110" href="#110">110</a>             <em class="comment">//handle the Status-Code</em>
<a name="111" href="#111">111</a>             <strong>int</strong> to = statusLine.indexOf(<span class="string">" "</span>, at);
<a name="112" href="#112">112</a>             <strong>if</strong> (to &lt; 0) {
<a name="113" href="#113">113</a>                 to = length;
<a name="114" href="#114">114</a>             }
<a name="115" href="#115">115</a>             <strong>try</strong> {
<a name="116" href="#116">116</a>                 <strong>this</strong>.statusCode = Integer.parseInt(statusLine.substring(at, to));
<a name="117" href="#117">117</a>             } <strong>catch</strong> (NumberFormatException e) {
<a name="118" href="#118">118</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/ProtocolException.html">ProtocolException</a>(
<a name="119" href="#119">119</a>                     <span class="string">"Unable to parse status code from status line: '"</span> 
<a name="120" href="#120">120</a>                     + statusLine + <span class="string">"'"</span>);
<a name="121" href="#121">121</a>             }
<a name="122" href="#122">122</a>             <em class="comment">//handle the Reason-Phrase</em>
<a name="123" href="#123">123</a>             at = to + 1;
<a name="124" href="#124">124</a>             <strong>if</strong> (at &lt; length) {
<a name="125" href="#125">125</a>                 <strong>this</strong>.reasonPhrase = statusLine.substring(at).trim();
<a name="126" href="#126">126</a>             } <strong>else</strong> {
<a name="127" href="#127">127</a>                 <strong>this</strong>.reasonPhrase = <span class="string">""</span>;
<a name="128" href="#128">128</a>             }
<a name="129" href="#129">129</a>         } <strong>catch</strong> (StringIndexOutOfBoundsException e) {
<a name="130" href="#130">130</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/HttpException.html">HttpException</a>(<span class="string">"Status-Line '"</span> + statusLine + <span class="string">"' is not valid"</span>); 
<a name="131" href="#131">131</a>         }
<a name="132" href="#132">132</a>         <em class="comment">//save the original Status-Line</em>
<a name="133" href="#133">133</a>         <strong>this</strong>.statusLine = statusLine;
<a name="134" href="#134">134</a>     }
<a name="135" href="#135">135</a> 
<a name="136" href="#136">136</a> 
<a name="137" href="#137">137</a>     <em class="comment">// --------------------------------------------------------- Public Methods</em>
<a name="138" href="#138">138</a> 
<a name="139" href="#139">139</a>     <em>/**<em>*</em></em>
<a name="140" href="#140">140</a> <em>     * @return the Status-Code</em>
<a name="141" href="#141">141</a> <em>     */</em>
<a name="142" href="#142">142</a>     <strong>public</strong> <strong>final</strong> <strong>int</strong> getStatusCode() {
<a name="143" href="#143">143</a>         <strong>return</strong> statusCode;
<a name="144" href="#144">144</a>     }
<a name="145" href="#145">145</a> 
<a name="146" href="#146">146</a>     <em>/**<em>*</em></em>
<a name="147" href="#147">147</a> <em>     * @return the HTTP-Version</em>
<a name="148" href="#148">148</a> <em>     */</em>
<a name="149" href="#149">149</a>     <strong>public</strong> <strong>final</strong> String getHttpVersion() {
<a name="150" href="#150">150</a>         <strong>return</strong> httpVersion;
<a name="151" href="#151">151</a>     }
<a name="152" href="#152">152</a> 
<a name="153" href="#153">153</a>     <em>/**<em>*</em></em>
<a name="154" href="#154">154</a> <em>     * @return the Reason-Phrase</em>
<a name="155" href="#155">155</a> <em>     */</em>
<a name="156" href="#156">156</a>     <strong>public</strong> <strong>final</strong> String getReasonPhrase() {
<a name="157" href="#157">157</a>         <strong>return</strong> reasonPhrase;
<a name="158" href="#158">158</a>     }
<a name="159" href="#159">159</a> 
<a name="160" href="#160">160</a>     <em>/**<em>*</em></em>
<a name="161" href="#161">161</a> <em>     * Return a string representation of this object.</em>
<a name="162" href="#162">162</a> <em>     * @return a string represenation of this object.</em>
<a name="163" href="#163">163</a> <em>     */</em>
<a name="164" href="#164">164</a>     <strong>public</strong> <strong>final</strong> String toString() {
<a name="165" href="#165">165</a>         <strong>return</strong> statusLine;
<a name="166" href="#166">166</a>     }
<a name="167" href="#167">167</a> 
<a name="168" href="#168">168</a>     <em>/**<em>*</em></em>
<a name="169" href="#169">169</a> <em>     * Tests if the string starts with 'HTTP' signature.</em>
<a name="170" href="#170">170</a> <em>     * @param s string to test</em>
<a name="171" href="#171">171</a> <em>     * @return &lt;tt>true&lt;/tt> if the line starts with 'HTTP' </em>
<a name="172" href="#172">172</a> <em>     *   signature, &lt;tt>false&lt;/tt> otherwise.</em>
<a name="173" href="#173">173</a> <em>     */</em>
<a name="174" href="#174">174</a>     <strong>public</strong> <strong>static</strong> <strong>boolean</strong> startsWithHTTP(<strong>final</strong> String s) {
<a name="175" href="#175">175</a>         <strong>try</strong> {
<a name="176" href="#176">176</a>             <strong>int</strong> at = 0;
<a name="177" href="#177">177</a>             <strong>while</strong> (Character.isWhitespace(s.charAt(at))) {
<a name="178" href="#178">178</a>                 ++at;
<a name="179" href="#179">179</a>             }
<a name="180" href="#180">180</a>             <strong>return</strong> (<span class="string">"HTTP"</span>.equals(s.substring(at, at + 4)));
<a name="181" href="#181">181</a>         } <strong>catch</strong> (StringIndexOutOfBoundsException e) {
<a name="182" href="#182">182</a>             <strong>return</strong> false;
<a name="183" href="#183">183</a>         }
<a name="184" href="#184">184</a>     }
<a name="185" href="#185">185</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

